/* $Header:   F:/source/cwright/cwstart/asm.c_v   1.30   26 Jul 1993 10:16:42   ericj  $ */
/*
 *
 *    ASP coloring dll.
 *    
 *	This Dll color an ASP file like Visual Interdev does.
 *    
 *  The number is colored with the ColorAlternate2
 *  The string is colored with the ColorAlternate1  
 *  The operator is colored with the ColorAlternate8
 *  The comment is colored with the ColorComments
 *  The HTML keywords is colored with the ColorKeywords -> Keyword
 *  The HTML attributs is colored with the ColorAlternate5 -> User 1
 *  The VB keywords is colored with the ColorAlternate6 -> User 2
 *  The TAG ASP is colored with the ColorAlternate9
 *    
 *  The HTML keyword is the W3C list keyword
 *  The HTML Attribut is the W3C list Attribut
 *  The VB keyword is the VB standard keyword and ASP object
 *    
 *    
 *  Make by Franck POCHET - fpochet@free.fr
 *
 */

#include <windows.h>
#include <string.h>
#include <ctype.h>
#include "exports.h"
#include "cwstart.h"

LIBMAIN    /* defines the LibMain() */


#define MAX_BUF_LEN    1024

static LPSTR   asp_line_comment = "'";

static LPVOID _asp_hash_names        = NIL;    /* pointer to the hash table containing */
                                               /* all 'ASP' keyword names. */

static LPVOID _asp_hash_names_1      = NIL;    /* pointer to optional hash table containing */
static int    _asp_hash_size_1       = 500;     /* user defined keyword names and size of
                                               /* table. When created these key
                                               /* are set to Color Alternate5 */           
                        

static LPVOID _asp_hash_names_2      = NIL;    /* pointer to optional hash table containing */
static int    _asp_hash_size_2       = 500;     /* user defined keyword names and size of
                                               /* table. When created these key
                                               /* are set to Color Alternate6 */              

static LPVOID _asp_hash_templates    = NIL;    /* pointer to the hash table containing */
                                               /* an abbreviated name and its template */

/* Define a structure to hold an abbreviation and the template to be
 * expanded when the abbreviation is entered into the buffer.
 * This structure will be the element in the hash table _asp_hash_templates.
 */
typedef struct _LanguageTemplate {         
    LPSTR abbrev;
    LPSTR template;
} LanguageTemplate;


/* This string contains all keyword names which will be indented an extra level.
 */
LPSTR ASP_INDENT_STR = "\377";

/*
 * _asp_templates[] contains the keyword abbreviation and the template for the
 * abbreviation.  To add a new name, insert it before the NIL entry or
 * call _asp_assign_template().
 *
 * The special characters within the template are:
 *
 *     \n - new line
 *     &  - cursor position after template insertion
 *     @  - backspace
 *     \c - insert 'c' literally
 *  
 *  Standard Template expansion
 */
LanguageTemplate _asp_templates[] = {
//    Abbreviation                       Template
    { "Ifl"       , "If & Then" },
    { "Ifb"       , "If & Then\nEnd If" },
    { "Ei" , "End If" },   
    { "rw|RW" , "Response.Write(\"&\")" },   
    { "iv|IV" , "value=\"&\"" },   
    { "rq|RQ" , "Request(\"&\")" },   
    { "trq|TRQ" , "Trim(Request(\"&\"))" },   
    { "ex|EX" , "Execute(&)" },   
    { NIL        , NIL    },
};

/* Define the list of 'ASP' keyword names to appear in
 * the keyword color if language coloring is enabled.
 * W3C Tag Html
 */
LPSTR _asp_names[] = {
    "A",
    "ACRONYM",
    "ADDRESS",
    "APPLET",
    "AREA",
    "B",
    "BASE",
    "BASEFONT",
    "BDO",
    "BIG",
    "BLOCKQUOTE",
    "BODY",
    "BR",
    "BUTTON",
    "CAPTION",
    "CENTER",
    "CITE",
    "CODE",
    "COL",
    "COLGROUP",
    "DD",
    "DEL",
    "DFN",
    "DIR",
    "DIV",
    "DL",
    "DOCTYPE",
    "DT",
    "EM",
    "FIELDSET",
    "FONT",
    "FORM",
    "FRAME",
    "FRAMESET",
    "H1",
    "H2",
    "H3",
    "H4",
    "H5",
    "H6",
    "HEAD",
    "HR",
    "HTML",
    "I",
    "IFRAME",
    "IMG",
    "INPUT",
    "INS",
    "ISINDEX",
    "KBD",
    "LABEL",
    "LEGEND",
    "LI",
    "LINK",
    "MAP",
    "MENU",
    "META",
    "NOFRAMES",
    "NOSCRIPT",
    "OBJECT",
    "OL",
    "OPTION",
    "P",
    "PARAM",
    "PRE",
    "Q",
    "S",
    "SAMP",
    "SCRIPT",
    "SELECT",
    "SMALL",
    "SPAN",
    "STRIKE",
    "STRONG",
    "STYLE",
    "SUP",
    "TABLE",
    "TBODY",
    "TD",
    "TEXTAREA",
    "TFOOT",
    "TH",
    "THEAD",
    "TITLE",
    "TR",
    "TT",
    "U",
    "UL",
    "VAR",
    NIL
};

LPSTR _asp_names_1[] = {
    "ACCESSKEY",
    "ACTION",
    "ALIGN",
    "ALINK",
    "BACKGROUND",
    "BGCOLOR",
    "BORDER",
    "BOTTOMMARGIN",
    "CELLPADDING",
    "CELLSPACING",
    "CHECKED",
    "CHARSET",
    "CLASS",
    "COLOR",
    "COLS",
    "COLSPAN",
    "CONTENT",
    "DATAFLD",
    "DATASRC",
    "DIR",
    "FACE",
    "FILE",
    "HEIGHT",
    "HREF",
    "ID",
    "LANGUAGE",
    "LEFTMARGIN",
    "MARGINWIDTH",
    "MARGINHEIGHT",
    "MAXLENGTH",
    "METHOD",
    "NAME",
    "NOSHADE",
    "NOWRAP",
    "REL",
    "RIGHTMARGIN",
    "ROWS",
    "ROWSPAN",
    "SELECTED",
    "SIZE",
    "SRC",
    "STYLE",
    "TABINDEX",
    "TARGET",
    "TEXT",
    "TOPMARGIN",
    "TYPE",
    "VALIGN",
    "VALUE",
    "VLINK",
    "WIDTH",
    NIL
};

LPSTR _asp_names_2[] = {
    "AND",
    "BOF",
    "BYVAL",
    "CDBL",
    "CINT",
    "CLNG",
    "CLOSE",
    "CREATEOBJECT",
    "CSTR",
    "DATE",
    "DAY",
    "DIM",
    "EACH",
    "ELSE",
    "ELSEIF",
    "END",
    "EOF",
    "EXECUTE",
    "EXIT",
    "DO",
    "FOR",
    "FORMATNUMBER",
    "FUNCTION",
    "IF",
    "IN",
    "INCLUDE",
    "ISNULL",
    "LEFT",
    "LEN",
    "LOOP",
    "MID",
    "MOD",
    "MONTH",
    "MOVEFIRST",
    "MOVENEXT",
    "NEXT",
    "NOT",
    "NOW",
    "OR",
    "PRIVATE",
    "PUBLIC",
    "QUERYSTRING",
    "REDIRECT",
    "REPLACE",
    "RIGHT",
    "SERVER",
    "SET",
    "THEN",
    "TO",
    "UNTIL",
    "WHILE",
    "APPLICATION",
    "REQUEST",
    "RESPONSE",
    "SERVER",
    "SUB",
    "URLENCODE",
    "WRITE",
    "YEAR",
    NIL
};

static long _asp_in_comment( long offset );

void DLL _asp_init( void );
BOOL DLL _asp_expand( void );
long DLL _asp_language_colors_update( long firstline, long lastline );
void DLL _asp_language_colors( long numlines );
void DLL _asp_assign_template( LPSTR abbrev, LPSTR template );
void DLL _asp_add_keyword( LPSTR keyword, int table );
BOOL DLL _asp_indent( void );
void DLL _asp_hash_size( int ht, int size );
void DLL _asp_routines( void);


void DLL 
_init()
{
    _asp_init();
    
    /* This line causes .yyy files to be treated like .asp files    */
    ExtAlias(".yyy", ".asp");
}


/*
 ** ASPSetCommentChar()
 *
 *  Sets what character to use to signal the beginning of a 
 *  "one line" comment.
 */

void DLL
ASPSetCommentChar(LPSTR CharStr)
{
    if (CharStr && *CharStr)
        asp_line_comment[0] = CharStr[0];
}


/*
 ** _asp_init()
 *
 *  Initialize this module by exported any required functions and
 *  the hash tables needed to support indenting, template expandion
 *  and keyword coloring.
 */
void DLL
_asp_init( void )
{
    static BOOL firstTime = TRUE;
    int    i;

    if (firstTime)
    {
        /* _asp language handling functions get called via LibFunctionExec,
         * so they must be exported.
         */
        LibExport( "BOOL _asp_expand");
        LibExport( "_asp_assign_template LPSTR LPSTR");
        LibExport( "BOOL _asp_indent");
        LibExport( "long _asp_language_colors_update long long");
        LibExport( "_asp_language_colors long");
        LibExport( "ASPSetCommentChar LPSTR");
        LibExport( "_asp_add_keyword LPSTR int");
        LibExport( "_asp_hash_size int int");
		LibExport( "_asp_routines" );

        firstTime = FALSE;

        /* Create a hash table to hold all of the 'ASP' keyword names.
         */
        _asp_hash_names = HashCreateTable( 539 /* a prime # */, sizeof( LPSTR ), HASH_IGN_CASE );
        i = 0;

        while ( _asp_names[ i ] != NIL )
        {
            LPSTR XFAR *lpf = (LPSTR XFAR *)HashGetEntry( _asp_hash_names, 
                    _asp_names[i], strlen( _asp_names[i] ) );
            if (lpf)
            {
                *lpf = StrNew( _asp_names[i] );
                i++;
            }
        }

        _asp_hash_names_1 = HashCreateTable(_asp_hash_size_1, sizeof( LPSTR ), HASH_IGN_CASE );
        i = 0;

        while ( _asp_names_1[ i ] != NIL )
        {
            LPSTR XFAR *lpf = (LPSTR XFAR *)HashGetEntry( _asp_hash_names_1, 
                    _asp_names_1[i], strlen( _asp_names_1[i] ) );
            if (lpf)
            {
                *lpf = StrNew( _asp_names_1[i] );
                i++;
            }
        }

        _asp_hash_names_2 = HashCreateTable(_asp_hash_size_2, sizeof( LPSTR ), HASH_IGN_CASE );
        i = 0;

        while ( _asp_names_2[ i ] != NIL )
        {
            LPSTR XFAR *lpf = (LPSTR XFAR *)HashGetEntry( _asp_hash_names_2, 
                    _asp_names_2[i], strlen( _asp_names_2[i] ) );
            if (lpf)
            {
                *lpf = StrNew( _asp_names_2[i] );
                i++;
            }
        }

        /* Create a hash table to hold all of the 'ASP' template names.
         */
        _asp_hash_templates = HashCreateTable( 17 /* a prime # */, sizeof( LPSTR ), HASH_IGN_CASE );
        i = 0;

        while ( _asp_templates[ i ].abbrev != NIL )
        {
            _asp_assign_template( _asp_templates[i].abbrev, _asp_templates[i].template );
            i++;
        }
    }
}


void DLL
_asp_hash_size( int ht, int size )
{
	if (size > 0)
	{
		if (ht == 1)
			_asp_hash_size_1 = size;
		else if (ht == 2)
			_asp_hash_size_2 = size;
	}
}


/*
 ** _asp_expand()
 *
 *  DESCRIPTION:
 *    Attempts to perform 'ASP' language template expansion.  This function
 *    is normally bound to the <SPACE> key.  When invoked, it reads the 
 *    previous word.  If the word is in the list of defined templates,
 *    the template is extracted and inserted.  Some characters in the 
 *    templates have special meanings. They are:
 *
 *       \n - new line
 *       &  - cursor position after template insertion
 *       @  - backspace
 *       \  - take next character literally
 */
BOOL DLL
_asp_expand( void )
{
    LPVOID htEntry;
    LPSTR  _asp_string = NULL;
    LPSTR  str;
    int    i = 0;
    DWORD    dwLen;

    MarkSavePos();

    /* Check to see if we are currently positioned inside a 'ASP' comment
     */
    if (_asp_in_comment( -1L ) != -1)
        goto _asp_expand_incomplete;

    str = BufReadStr( 65535 );
    while (str[i] && !isspace(str[i]))
        i++;
    str[i] = '\0';

    _asp_string = StrTrim( str, " \t" );
    StrFree( str );

    if (!_asp_string)
        goto _asp_expand_incomplete;

    /* Search for a keyword match in the hash table.
     */
    dwLen = strlen(_asp_string);
    htEntry = HashFindEntry( _asp_hash_templates, _asp_string, strlen( _asp_string ) );
    StrFree( _asp_string );

    if (htEntry)
    {
        /* A template exists for the current keyword, delete the keyword
         * and insert the template.
         */
        MarkDropPos( 1 );
        str = *(LPSTR*)htEntry;
        BufDelChar(dwLen);

        _ext_expand_template( str );

    } 
    else
        goto _asp_expand_incomplete;
    return TRUE;

_asp_expand_incomplete:
    MarkRestorePos();

    return FALSE;
}

// ***********************************************************
// *** This function search regular expression in a string ***
// ***********************************************************
BOOL DLL
IsIn(char ch, LPSTR lpszReg)
{
  BOOL bRet = FALSE;
  long lLen;
  char szBuf[2];

  szBuf[0] = ch;
  szBuf[1] = 0;
  if (StrMatch(lpszReg, szBuf, SEARCH_FORWARD	| SEARCH_REGEX, &lLen))
    bRet = TRUE;
  return bRet;
}

// ************************************************************
// *** This function try to find the digit char in a string ***
// ************************************************************
BOOL DLL
IsNumeric(char ch)
{
  return IsIn(ch, "[0-9]");
}

// *****************************************************************
// *** This function try to find alpha or digit char in a string ***
// *****************************************************************
BOOL DLL
IsAlphaNum(char ch)
{
  return IsIn(ch, "[0-9A-Za-z_]");
}

// ***********************************************************
// *** This function try to find operator char in a string ***
// ***********************************************************
BOOL DLL
IsOperator(char ch)
{
  return IsIn(ch, "[=<>\\+\\&]");
}

// *************************************************************
// *** This function test if the string have only digit char ***
// *************************************************************
BOOL DLL
IsNumber(LPSTR lpszWord)
{
  BOOL bRet = TRUE;
  long lLen;
  long lI;

  lLen = strlen(lpszWord);
  for (lI = 0; lI < lLen; lI++)
    {
    if (!IsNumeric(lpszWord[lI]))
      {
      bRet = FALSE;
      break;
      }
    }
  return bRet;
}

// *************************************************
// *** This function convert a char in lowercase ***
// *************************************************
char DLL
LowerChar(char ch)
{
  char cEnd;

  cEnd = ch;
  if (cEnd >= 97 && cEnd <= 122)
    cEnd -= 32;
  return cEnd;
}

// ****************************************************************
// *** This function color a number of char in a specific color ***
// ****************************************************************
void DLL
ColorWord(int nColor, long lStartWord, long lEndWord)
{
  long lCurOffset;

  lCurOffset = _PosQOffset();
  _PosInit( lStartWord );
  _PosSetColor( nColor, lEndWord - lStartWord );
  _PosInit( lCurOffset );
}

// *************************************
// *** This function color a numbers ***
// *************************************
void DLL
ColorWordNumber(long lStartWord, long lEndWord)
{
  int   number_color    = ColorAlternate2( -1 );

	ColorWord(number_color, lStartWord, lEndWord);
}

// ***************************************
// *** This function color an operator ***
// ***************************************
void DLL
ColorWordOperator(long lStartWord, long lEndWord)
{
  int   operator_color    = ColorAlternate8( -1 );

	ColorWord(operator_color, lStartWord, lEndWord);
}

// **************************************
// *** This function color a HTML Tag ***
// **************************************
void DLL
ColorWordHtmlTag(long lStartWord, long lEndWord)
{
  int  keyword_color = ColorKeywords(-1);

	ColorWord(keyword_color, lStartWord, lEndWord);
}

// *******************************************
// *** This function color a HTML Attribut ***
// *******************************************
void DLL
ColorWordHtmlAttr(long lStartWord, long lEndWord)
{
  int  Attrib_Color = ColorAlternate5(-1);

	ColorWord(Attrib_Color, lStartWord, lEndWord);
}

// ****************************************
// *** This function color a VB keyword ***
// ****************************************
void DLL
ColorWordVB(long lStartWord, long lEndWord)
{
  int  VB_Color = ColorAlternate6(-1);

	ColorWord(VB_Color, lStartWord, lEndWord);
}

// ************************************
// *** This function color a string ***
// ************************************
void DLL
ColorWordString(long lStartWord, long lEndWord)
{
  int  String_color = ColorAlternate1(-1);

	ColorWord(String_color, lStartWord, lEndWord);
}

// *************************************
// *** This function color a comment ***
// *************************************
void DLL
ColorWordComment(long lStartWord, long lEndWord)
{
  int  Comment_color = ColorComments(-1);

	ColorWord(Comment_color, lStartWord, lEndWord);
}

// *************************************
// *** This function color a ASP tag ***
// *************************************
void DLL
ColorWordTag(long lStartWord, long lEndWord)
{
  int  Tag_color = ColorAlternate9(-1);

	ColorWord(Tag_color, lStartWord, lEndWord);
}

// *****************************************************
// *** This function read char and return it as word ***
// *****************************************************
void DLL
ReadCurWord(long lStartWord, long lEndWord, LPSTR lpszWord)
{
  long lCurOffset;
  long lCurLine;
  long lI;
  char ch;

  // Save buffer pos
  lCurOffset = _PosQOffset();
  _PosInit( lStartWord );
  lCurLine = _PosQLine();
  ch = _PosCurrentChar();
  lI = 0;
  while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine && _PosQOffset() < lEndWord)
    {
    lpszWord[lI] = ch;
    ch = _PosNextChar();
    lI++;
    }
  lpszWord[lI] = 0;
	_PosInit( lCurOffset );
}

// *****************************************************
// *** This function try to find the begin of a word ***
// *****************************************************
// * The word is only alphanum. So the word '#include' 
// * is colored only 'include'
long DLL
GetStartWord(void)
{
  BOOL bBreak;
  long lCurOffset;
  long lCurLine;
  long lStartWord;
  char ch;

  // Save buffer pos
  lCurOffset = _PosQOffset();
  _PosInit( lCurOffset );
  lCurLine = _PosQLine();
  lStartWord = lCurOffset;
	bBreak = FALSE;
  ch = _PosCurrentChar();
  while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine)
    {
    // try to find the first not alphanum char
    if (!IsAlphaNum(ch))
      {
      _PosNextChar();
      lStartWord = _PosQOffset();
			bBreak = TRUE;
      break;
      }
    ch = _PosPrevChar();
    }
  // test if not at the begin of the line
  if(lStartWord != _PosQOffset() && !bBreak)
		{
		_PosNextChar();
		lStartWord = _PosQOffset();
		}
  _PosInit( lCurOffset );
  return lStartWord;
}

// *****************************************************
// *** This function try to find the end of a word ***
// *****************************************************
// * The word is only alphanum. So the word '#include' 
// * is colored only 'include'
long DLL
GetEndWord(void)
{
  long lCurOffset;
  long lCurLine;
  long lEndWord;
  char ch;

  // Save buffer pos
  lCurOffset = _PosQOffset();
  _PosInit( lCurOffset );
  lCurLine = _PosQLine();
  lEndWord = lCurOffset;
  ch = _PosCurrentChar();
  while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine)
    {
    // try to find the next char that is not an alphanum
    if (!IsAlphaNum(ch))
      {
      lEndWord = _PosQOffset();
      break;
      }
    ch = _PosNextChar();
    }
  _PosInit( lCurOffset );
  return lEndWord;
}

// *********************************************
// *** This function color numbers of a line ***
// *********************************************
void DLL
ColorNumber(void)
{
  long lCurOffset;
  long lCurLine;
  long lStartWord;
  long lEndWord;
  char ch;
  char szWord[MAX_BUF_LEN];

  // Save buffer pos
  lCurOffset = _PosQOffset();
  _PosInit( lCurOffset );
  lCurLine = _PosQLine();
  ch = _PosCurrentChar();
  while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine)
    {
    if (IsNumeric(ch))
      {
      // retrieve the entire number
      lStartWord = GetStartWord();
      lEndWord = GetEndWord();
      ReadCurWord(lStartWord, lEndWord, szWord);
      // test if the entire word is a number. eg: 45a7 must not be number colored
      if (IsNumber(szWord))
        ColorWordNumber(lStartWord, lEndWord);
      _PosInit(lEndWord);
      }
    ch = _PosNextChar();
    }
  _PosInit( lCurOffset );
}

// **********************************************
// *** This function color operators of a line ***
// **********************************************
void DLL
ColorOperator(void)
{
  long lCurOffset;
  long lCurLine;
  long lStartWord;
  long lEndWord;
  char ch;

  // Save buffer pos
  lCurOffset = _PosQOffset();
  _PosInit( lCurOffset );
  lCurLine = _PosQLine();
  ch = _PosCurrentChar();
  while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine)
    {
    if (IsOperator(ch))
      {
      // retrieve the entire operator
      lStartWord = _PosQOffset();
      _PosNextChar();
      lEndWord = _PosQOffset();
      // repos to color 2 operator that follow. eg : &&
      _PosPrevChar();
      ColorWordOperator(lStartWord, lEndWord);
      _PosInit(_PosQOffset());
      }
    ch = _PosNextChar();
    }
  _PosInit( lCurOffset );
}

// ***********************************************************************************
// *** This function color Kewords (HTML Tag, HTML Attribut, VB keyword) of a line ***
// ***********************************************************************************
void DLL
ColorKeyword(void)
{
  BOOL bFind;
  long lCurOffset;
  long lCurLine;
  long lStartWord;
  long lEndWord;
  char ch;
  char szWord[MAX_BUF_LEN];

  // Save buffer pos
  lCurOffset = _PosQOffset();
  _PosInit( lCurOffset );
  lCurLine = _PosQLine();
  bFind = FALSE;
  ch = _PosCurrentChar();
  while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine)
    {
    // try to find the begin of a keyword
    if (!bFind && IsAlphaNum(ch))
      {
	  // save pos of the begin of the keyword
      lStartWord = _PosQOffset();
      bFind = TRUE;
      }
    // If a keyword found, try to find end
    if (bFind && !IsAlphaNum(ch))
      {
      lEndWord = _PosQOffset();
      ReadCurWord(lStartWord, lEndWord, szWord);
      // Try to find HTML tag -> Keyword
      if (HashFindEntry(_asp_hash_names, szWord, strlen(szWord)))
        ColorWordHtmlTag(lStartWord, lEndWord);
      // Try to find HTML Attrib -> User 1
      if (HashFindEntry(_asp_hash_names_1, szWord, strlen(szWord)))
        ColorWordHtmlAttr(lStartWord, lEndWord);
      // Try to find VB keyword -> User 2
      if (HashFindEntry(_asp_hash_names_2, szWord, strlen(szWord)))
        ColorWordVB(lStartWord, lEndWord);
      _PosInit(lEndWord);
      bFind = FALSE;
      }
    ch = _PosNextChar();
    }
  _PosInit( lCurOffset );
}

// *********************************************
// *** This function color strings of a line ***
// *********************************************
// * The string could be in an ASP tag and the ASP tag in
// * in a string. So, when an ASP tag it's in a string
// * then the color of the string stop and 
// * restart at the end of the ASP tag. But if a 
// * string is in an ASP tag, then it's must be
// * colored.
void DLL
ColorString(void)
{
  BOOL bFind;
  BOOL bFindTag;
  BOOL bTag;
  long lCurOffset;
  long lCurLine;
  long lStartString;
  long lEndString;
  long lStartTag;
  char ch, cPrevCh, cTag;

  // Save buffer pos
  lCurOffset = _PosQOffset();
  _PosInit( lCurOffset );
  lCurLine = _PosQLine();
  bFind = FALSE;
  bTag = FALSE;
	bFindTag = FALSE;
  cPrevCh = 0;
  ch = _PosCurrentChar();
  while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine)
    {
    // try to find a string
    if (!bFind && ch == '"')
     	{
      lStartString = _PosQOffset();
      bFind = TRUE;
	  	goto BclString;
      }
    // try to find  a string in an ASP tag
    if (bTag && !bFindTag && ch == '"')
     	{
      lStartString = _PosQOffset();
      bFindTag = TRUE;
      goto BclString;
      }
    // try to find an ASP tag in string
    if (!bTag && bFind && ch == '<')
      {
      lStartTag = _PosQOffset();
		  cTag = _PosNextChar();
		  _PosInit(lStartTag);
		  if (cTag == '%')
				{
				ColorWordString(lStartString, lStartTag);
	      _PosInit(lStartTag);
	      bTag = TRUE;
		    goto BclString;
				}
      }
    // try to find end ASP tag in a string
    if (bTag && bFind && ch == '%')
      {
      lStartTag = _PosQOffset();
		  cTag = _PosNextChar();
		  _PosInit(lStartTag);
		  if (cTag == '>')
				{
				ch = _PosNextChar();
				ch = _PosNextChar();
				lStartString = _PosQOffset();
				bTag = FALSE;
				bFindTag = FALSE;
				}
      }
    // try to find end of the string in an ASP tag
    if (bTag && bFindTag && ch == '"' && cPrevCh != '\\')
      {
      ch = _PosNextChar();
	  	lEndString = _PosQOffset();
			if (ch != '"')
				{
				ColorWordString(lStartString, lEndString);
      	bFindTag = FALSE;
				}
			_PosInit(lEndString);
      goto BclString;
      }
    // try to find end string
    if (bFind && ch == '"' && cPrevCh != '\\')
      {
      ch = _PosNextChar();
	  	lEndString = _PosQOffset();
			if (ch != '"')
				{
	      ColorWordString(lStartString, lEndString);
	      bFind = FALSE;
				}
      _PosInit(lEndString);
      }
BclString:
    cPrevCh = ch;
    ch = _PosNextChar();
    }
  _PosInit( lCurOffset );
}

// *********************************************
// *** This function color numbers of a line ***
// *********************************************
// * Comment could be at the start of the line
// * or in an ASP tag or at the end of a line
void DLL
ColorComment(void)
{
  BOOL bFind;
  BOOL bTag;
	BOOL bChar;
  long lCurOffset;
  long lCurLine;
  long lStartComment;
  long lEndComment;
  long lStartTag;
  long lEndLine;
  char ch, cTag;

  // Save buffer pos
  lCurOffset = _PosQOffset();
	_PosInit( lCurOffset );
  lCurLine = _PosQLine();
  bFind = FALSE;
  bTag = FALSE;
	bChar = FALSE;
  ch = _PosCurrentChar();
  while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine)
    {
    // try to find comment a the start of the line
    if (!bFind && !bChar && ch == '\'')
			{
			lStartComment = _PosQOffset();
			bFind = TRUE;
			ch = _PosNextChar();
			}
    // test if the first char is not a comment
    if (!bChar && ch != ' ' && ch != '\t')
			bChar = TRUE;
	// try to find a comment in an ASP tag
	if (bTag && !bFind && ch == '\'')
      {
      lStartComment = _PosQOffset();
      bFind = TRUE;
      goto BclComment;
      }
    // Try to find an ASP tag
    if (!bTag && ch == '<')
      {
      lStartTag = _PosQOffset();
		  cTag = _PosNextChar();
		  _PosInit(lStartTag);
		  if (cTag == '%')
				{
				_PosInit(lStartTag);
	      bTag = TRUE;
		    goto BclComment;
				}
      }
    // try to find end ASP tag
    if (bTag && ch == '%')
      {
      lStartTag = _PosQOffset();
		  cTag = _PosNextChar();
		  _PosInit(lStartTag);
		  if (cTag == '>')
				{
				lEndComment = _PosQOffset();
				bTag = FALSE;
				if (bFind)
					{
					ColorWordComment(lStartComment, lEndComment);
					bFind = FALSE;
					_PosInit(lEndComment);
					}
				}
      }
BclComment:
    ch = _PosNextChar();
    }
	// case where comment is at the begining of the line
	if (bFind)
		{
		lEndComment = _PosQOffset();
		ColorWordComment(lStartComment, lEndComment);
		}
  // color comment at the end of a line
  _PosInit( lCurOffset );
  bFind = FALSE;
  // end of line
  _PosNextLine(0);
  lEndLine = _PosQOffset();
  ch = _PosPrevChar();
  while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine)
    {
    // try to find comment a the end of the line
    if (ch == '\'')
		{
		lStartComment = _PosQOffset();
		bFind = TRUE;
		break;
		}
    // test if the cur char is not an alphanum
    if (ch != ' ' && ch != '\t' && ch != ',' && ch != ':' && !IsAlphaNum(ch))
		break;
    ch = _PosPrevChar();
    }
	// Test if comment at end of line found
	if (bFind)
		{
		lEndComment = lEndLine;
		ColorWordComment(lStartComment, lEndComment);
		}
  _PosInit( lCurOffset );
}

// **********************************************
// *** This function color ASP Tags of a line ***
// **********************************************
void DLL
ColorTag(void)
{
	long lCurOffset;
	long lCurLine;
	long lStartTag;
	long lEndTag;
	long lCurPos;
	char ch;

	// Save buffer pos
	lCurOffset = _PosQOffset();
	_PosInit( lCurOffset );
	lCurLine = _PosQLine();
	ch = _PosCurrentChar();
	while (ch != '\n' && ch != 0 && ch != EOF_CHAR && _PosQLine() == lCurLine)
	{
		// try to find ASP tag
		if (ch == '<')
		{
			lStartTag = _PosQOffset();
			ch = _PosNextChar();
			if (ch == '%')
			{
				lCurPos = _PosQOffset();
				ch = _PosNextChar();
				lEndTag = _PosQOffset();
				ColorWordTag(lStartTag, lEndTag);
				_PosInit(lCurPos);
				ch = '%';
			}
		}
		// try to find end ASP tag
		if (ch == '%')
		{
			lStartTag = _PosQOffset();
			ch = _PosNextChar();
			if (ch == '>')
			{
				lCurPos = _PosQOffset();
				ch = _PosNextChar();
				lEndTag = _PosQOffset();
				ColorWordTag(lStartTag, lEndTag);
				_PosInit(lCurPos);
			}
			else
				_PosInit(lStartTag);
		}
		ch = _PosNextChar();
	}
	_PosInit( lCurOffset );
}

// ************************************************
// *** This function color a line of the buffer ***
// ************************************************
// * The order of the call color function is that
// * the first one could change when the second is
// * call. Eg: a number could change if it's in a
// * comment. The ASP Tag is the last cause it 
// * couldn't be in another color change.
void DLL
ColorLine(void)
{
  long lCurOffset;

  lCurOffset = _PosQOffset();
  _PosInit( lCurOffset );
  ColorNumber();
  _PosInit( lCurOffset );
  ColorOperator();
  _PosInit( lCurOffset );
  ColorKeyword();
  _PosInit( lCurOffset );
  ColorString();
  _PosInit( lCurOffset );
  ColorComment();
  _PosInit( lCurOffset );
  ColorTag();
  _PosInit( lCurOffset );
}

/*
 ** _asp_language_colors_update()
 *
 *  This function does an intermediate update of the colors within
 *  a range of line numbers (firstline and lastline).  It must also
 *  determine if the first and last line specified are within a
 *  comment and act appropriately.
 */
long DLL
_asp_language_colors_update( long firstline, long lastline )
{
    long startoff;
    long count;

    if (firstline && lastline)
    {
        /* Clear all attributes for the line range and
         * the reset them within _asp_language_colors.
         */
        AttrSetColor( firstline, lastline, 1L, 0x7FFFFFFFL, 0 );
        // Ctrl-Home
        _PosInit( 0 );
        // Test if must go to a line
        if (firstline != 1)
            _PosNextLine( firstline - 1);
        // Home
        _PosPrevLine( 0L );
        startoff = _PosQOffset();
        _PosInit( startoff );
        // Color line from Startoff
        _asp_language_colors( lastline - firstline + 1 );
    }

    count = lastline - firstline;
    return(count);
}
                    
void DLL
_asp_language_colors( long numlines )
{
  long lCurOffset;

  // Test if color all buffer
  if (numlines == -1)
    numlines = 0x7FFFFFFF;
  while (numlines)
    {
    // Home
    _PosPrevLine( 0L );
    lCurOffset = _PosQOffset();
	_PosInit( lCurOffset );
	// Color the line
	ColorLine();
    // reinit pos before color the line
    _PosInit( lCurOffset );
    // Go next line - Stop if end of buf
    if (_PosNextLine(1) < 1)
      break;
    numlines--;
    }
}

/*
 ** _asp_add_keyword()
 *
 *  PARAMETERS:
 *    keyword - the keyword to add to the user-defined keyword table
 *    table   - the 1-based index of the table to which to add the keyword
 *
 *  DESCRIPTION:
 *    Provide a means of adding user-defined keywords for special
 *    coloring
 */
void DLL
_asp_add_keyword( LPSTR keyword, int table )
{
    if (keyword && *keyword && table >= 0)
    {
        LPSTR XFAR *lpf;
        LPVOID  ht;

        switch( table )
        {
        case 0:
            ht = _asp_hash_names;
            break;
        case 1:
            if (_asp_hash_names_1 == NULL)
                _asp_hash_names_1 = HashCreateTable( _asp_hash_size_1, sizeof( LPSTR ), 0 );
            ht = _asp_hash_names_1;
            break;
        case 2:
            if (_asp_hash_names_2 == NULL)
                _asp_hash_names_2 = HashCreateTable( _asp_hash_size_2, sizeof( LPSTR ), 0 );
            ht = _asp_hash_names_2;
            break;
        }

        lpf = (LPSTR XFAR *)HashGetEntry( ht, keyword, strlen( keyword ) );
        if (lpf)
        {
            *lpf = StrNew( keyword );
        }
    }
}


/*
 ** _asp_assign_template()
 *
 *  PARAMETERS:
 *    abbrev   - the keyword abreviation used to locate a template
 *    template - the encoded template string associated with 'abbrev'
 *
 *  DESCRIPTION:
 *    Provide a means of adding or modifying 'ASP' template strings
 *    without changing the code.
 */
void DLL
_asp_assign_template( LPSTR abbrev, LPSTR template )
{
    _ext_assign_template( _asp_hash_templates, abbrev, template );
}


/*
 ** _asp_indent()
 *
 *  DESCRIPTION:
 *    Attempts to perform 'ASP' language smart indenting.  This function
 *    will behave differently based on the following conditions:
 *
 *    1. Within a comment - normal indentation
 *
 *    2. Not positioned at end of line - normal indentation
 *
 *    3. Current line prefixed by a name in ASP_INDENT_STR - perform smart
 *       indentation.  
 */
BOOL DLL
_asp_indent( void )
{
    long   curline;
    long   col;
    LPSTR  _asp_string;
    LPSTR  str;
    long   matchpos;

    MarkSavePos();

    curline = BufQCurrentLine();

    /* Check to see if we are currently positioned inside a 'ASP' comment
     */
    if (_asp_in_comment( -1L ) != -1)
        goto _asp_indent_incomplete;

    /* Not in a comment so indent according to the current 'ASP' construct.
     */
    if (!SrchFind( "^[ \t]*[a-zA-Z_]+\\c([ \t]|$)", SEARCH_REGEX , NIL )
            || (BufQCurrentLine() != curline) )
        goto _asp_indent_incomplete;

    /* Read the keyword at the beginning of the current line.
     */
    col = BufQCurrentCol();
    SrchFind( "(^|[^a-zA-Z_])\\c[a-zA-Z_]", SEARCH_REGEX , NIL );
    str = BufReadStr( col - BufQCurrentCol() );
    _asp_string = StrTrim( str, " \t" );
    StrFree( str );

    /* Set prefix and suffix to \377 to perform a quick lookup of the name
     */
    str = StrNew( "\377" );
    _asp_string = StrAppend( _asp_string, str );
    str = StrAppend( str, _asp_string );
    StrFree( _asp_string );
    
    matchpos = StrMatch( str, ASP_INDENT_STR, SEARCH_IGCASE | SEARCH_FORWARD, NIL );
    StrFree( str );

    if (!matchpos)
        /* Not a 'ASP' keyword, do normal indentation. */
        goto _asp_indent_incomplete;
        
    MarkRestorePos();

    _ext_insert_indented_EOL();
    BufInsertChar( '\t' );
    return TRUE;

    _asp_indent_incomplete:
        MarkRestorePos();

    return FALSE;
}

/*
 ** _asp_routines()
 *
 *  DESCRIPTION:
 *    Locates function definitions for selective display mode.
 *    This function gets called by the Codewright API call Routines()
 *    if the current file is a .ASP file.
 *    The code here is taken from _c_routines; modify it as needed.
 */
void DLL
_asp_routines( void )
{
	int   matches = 0;
	LPSTR str     = "^[a-zA-Z0-9_].*\\((.|\n)*\\)";
	LPSTR stre    = "^[a-zA-Z0-9_].*\\((.|\n)*\\)[ \t\n]*\\c[^ \t\n]";
	long  curline;
	UINT  ch;
	long  lines;

	SysWaitStart();

	MarkSavePos();

	BufSetAscii();
	MovTopBuf();

	while (SrchFind( str, SEARCH_REGEX | SEARCH_FORWARD, 0 ))
	{
		curline = BufQCurrentLine();

		SrchFind( stre, SEARCH_REGEX | SEARCH_FORWARD, 0 );

		ch = BufReadChar();
		if (ch != ';')
		{
			if (!matches)
				AttrSetVisible( 0, 0, 0 );
			matches++;
			lines = BufQCurrentLine() - curline
						- !!(ch == '{');
			AttrSetVisible( curline, curline + (lines < 0L ? 0L : lines), 1 );
			MovHome();
		}

		if (!MovDown( 1 ))
			break; 
	}

	if (matches)
	{
		BufSetCompact();
		MarkDropPos( 1 );
		MovTopBuf();
	}
	else
		MarkRestorePos();

	SysWaitEnd();

	MsgMessage( matches ? "" : "No routines found." );
}


/*--  Private functions --*/


/*
 ** _asp_in_comment()
 *
 *  Determines whether or not the current position in the buffer is
 *  located within a 'ASP' comment by search backward for a // or /* 
 *  comment declaration.
 *
 *  Returns -1 if not in a comment 
 *          >= 0 indicates the offset in the buffer where the comment begins
 */
static long
_asp_in_comment( long offset )
{
    WORD  ch;

    /* Check to see if we are currently positioned inside a 'ASP' comment
     */
    _PosInit( offset );
    ch = _PosCurrentChar();

    do
    {
        if (ch == '\n')
            return -1;
        else if (ch == (WORD)*asp_line_comment)
            return _PosQOffset();  /* currrent line is in a comment */
        ch = _PosPrevChar();
    } while (ch != EOF_CHAR);

    return -1L;
}

